/* eslint-disable @typescript-eslint/no-explicit-any */
// import melonjson from "./melon.json";
/**
 * 初始化和重置文书结构
 * @param widgetJson
 */
export const initJson = (widgetJson: any) => {
  widgetJson['subDomList'] = []
  widgetJson['activeId'] = ""
  widgetJson['activeDomName'] = ""
  // widgetJson['formConfig'] = {}
}

/**
 * 添加新的子元素
 * @param addItemDataOrigin 新元素
 * @param fatherId 父容器id
 * @param widgetJson w文书结构JSON
 */
export const addItem = (addItemDataOrigin: any, fatherId = "", widgetJson: any) => {
  const { addItemData, activeId, activeDomName } = formatAddItem(addItemDataOrigin)
  if (fatherId) { } else {
    widgetJson['subDomList'] = [addItemData]
  }
  widgetJson['activeId'] = activeId
  widgetJson['activeDomName'] = activeDomName
}

/**
 * 根据表单元素 格式化对应的属性
 * @param addItemDataOrigin
 */
const formatAddItem = (addItemDataOrigin: any) => {
  const addItemData = JSON.parse(JSON.stringify(addItemDataOrigin));
  let activeId = '';
  let activeDomName = '';
  addItemData['key'] = Date.now().toString().slice(-6);
  addItemData['id'] = `${addItemData['type']}-${addItemData['key']}`;
  activeId = addItemData['id']
  activeDomName = addItemData['displayName']
  addItemData['options'] = {
    name: `table-${addItemData['key']}`,
    hidden: false,
    customClass: ''
  };
  // 针对表格 需要初始化子单元格
  if (addItemData['type'] == 'table') {
    const key = addItemData['key'].slice(-1) + addItemData['key'].slice(0, -1);
    // 子单元格
    const colItem = {
      key: key,
      id: `table-cell-${key}`,
      category: "container",
      type: "table-cell",
      displayName: "子单元格",
      icon: "Monitor",
      merged: false,
      subDomList: [],
      options: {
        name: `table-cell-${key}`,
        hidden: false,
        colspan: 1,
        rowspan: 1,
        customClass: ''
      }
    };
    addItemData['subDomList'] = [[colItem]]
    // activeId = colItem['id']
    // activeDomName = colItem['displayName']
  }
  return {
    addItemData,
    activeId,
    activeDomName
  }
}
